/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod_$type } from "./IShortPeriodLongPeriod";
import { PercentagePriceOscillatorIndicatorStrategy } from "./PercentagePriceOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new PercentagePriceOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return PercentagePriceOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.q8));
    }
    set shortPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.q8, a);
    }
    qu() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.q7));
    }
    set longPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.q7, a);
    }
    qr() {
        return this.longPeriod;
    }
}
PercentagePriceOscillatorIndicator.$t = markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
PercentagePriceOscillatorIndicator.q8 = StrategyBasedIndicator.q6(10, PercentagePriceOscillatorIndicator.$);
PercentagePriceOscillatorIndicator.q7 = StrategyBasedIndicator.q2(30, PercentagePriceOscillatorIndicator.$);
//# sourceMappingURL=PercentagePriceOscillatorIndicator.js.map