/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { PolarBase } from "./PolarBase";
import { PathRenderer } from "./PathRenderer";
import { DefaultFlattener } from "./DefaultFlattener";
import { PolarBaseView } from "./PolarBaseView";
import { Number_$type, Point_$type, markType } from "igniteui-angular-core";
import { PolarLinePlanner } from "./PolarLinePlanner";
import { List$1 } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export class PolarLineSeriesBase extends PolarBase {
    constructor() {
        super();
        this.pc = null;
        this.pe = null;
        this.pd = null;
        this.pc = new PathRenderer(1, new DefaultFlattener());
        this.pe = new PathRenderer(0);
    }
    bf() {
        return new PolarLineSeriesBaseView(this);
    }
    i2(a) {
        super.i2(a);
        this.pf = a;
    }
    pg() {
        return 1;
    }
    get_pj() {
        return false;
    }
    get pj() {
        return this.get_pj();
    }
    get_pl() {
        return false;
    }
    get pl() {
        return this.get_pl();
    }
    om(a, b) {
        super.om(a, b);
        a.m.clear();
        let c = b.bs;
        let d = b.br;
        let e = this.nv != null ? this.nv.count : 0;
        let f = this.nw != null ? this.nw.count : 0;
        let g = Math.min(e, f);
        let h = ((() => {
            let $ret = new PolarLinePlanner();
            $ret.m = (i) => this.nj.a.getScaledAngle1(this.nv.item(i), this.nj.e, this.nj.d);
            $ret.q = g;
            $ret.n = (i) => this.nh.ly(this.nw.item(i), this.nj.g, this.nj.f, this.nj.i, this.nj.h);
            $ret.l = this.eu;
            $ret.f = this.n1;
            $ret.b = this.pg();
            $ret.o = (i) => this.pm(a, i);
            $ret.p = (i) => this.pn(a, i);
            $ret.ab = d;
            $ret.ac = c;
            $ret.d = this.pl;
            $ret.c = this.pj;
            return $ret;
        })());
        let i = new List$1(Number_$type, 0);
        for (let j = 0; j < g; j++) {
            if (this.pk(j)) {
                i.add(j);
            }
        }
        if (this.pl && i.count > 0) {
            i.add(i._inner[0]);
        }
        h.x(a.m, i);
    }
    pm(a, b) {
        return a.w._inner[b].x;
    }
    pn(a, b) {
        return a.w._inner[b].y;
    }
    pi() {
        return !this.ph();
    }
    ph() {
        let a = this.bs.n2;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    }
    pk(a) {
        return (this.nv.item(a) >= this.nj.a.kc && this.nv.item(a) <= this.nj.a.kb && this.nw.item(a) >= this.nj.b.kc && this.nw.item(a) <= this.nj.b.kb) || (isNaN_(this.nv.item(a)) || isNaN_(this.nw.item(a)));
    }
    h3(a, b) {
        super.h3(a, b);
        this.po(b);
    }
    oo(a, b) {
        super.oo(a, b);
        if (this.n1) {
            this.pd = this.pc;
        }
        else {
            this.pd = this.pe;
        }
        this.pd.b = this.pg();
        this.po(b);
        this.pp(a, b);
    }
}
PolarLineSeriesBase.$t = markType(PolarLineSeriesBase, 'PolarLineSeriesBase', PolarBase.$);
/**
 * @hidden
 */
export class PolarLineSeriesBaseView extends PolarBaseView {
    constructor(a) {
        super(a);
        this.cy = null;
        this.cy = a;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
PolarLineSeriesBaseView.$t = markType(PolarLineSeriesBaseView, 'PolarLineSeriesBaseView', PolarBaseView.$);
//# sourceMappingURL=PolarLineSeriesBase_combined.js.map