/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SplineSeriesBase } from "./SplineSeriesBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { typeCast, runOn, markType } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SplineSeriesBaseView } from "./SplineSeriesBaseView";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "igniteui-angular-core";
/**
 * @hidden
 */
export class SplineAreaSeries extends SplineSeriesBase {
    constructor() {
        super();
        this.q4 = null;
        this.q4 = new CategoryLineRasterizer();
        this.ab = SplineAreaSeries.$;
    }
    bf() {
        return new SplineAreaSeriesView(this);
    }
    nt() {
        return 1;
    }
    i2(a) {
        super.i2(a);
        this.q5 = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c8();
    }
    dh(a, b) {
        let c = this.lv(this.ly(a), true, false);
        if (this.ql(a, c, b)) {
            return true;
        }
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    o1(a, b) {
        super.o1(a, b);
        let c = this.ns.cn.d;
        let d = typeCast(SplineAreaSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(b);
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let g = false;
        let h = this.nr.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bs, b.br, this.qb.ca, f);
            this.ox(e, -1, this.valueColumn.count, this.qb, i, b.n);
        }
        let j = d.dj;
        let k = d.dk;
        let l = d.dl;
        let m = d.dm;
        this.nr.ae(j, true, false, true, true);
        this.nr.ae(k, true, false, true, true);
        this.nr.ae(l, false, true, false, false);
        this.nr.ae(m, false, true, false, false);
        l._opacity = this.nr.i * this.d6;
        m._opacity = 0.5 * this.nr.i * this.d6;
        if (b.cr(a)) {
            d.da(a.f.count, e, true, c, this.eu, (n, o, p, q, r) => this.pv(n, a.f.count, b), 1, a.f.count == 1 ? null : this.pa(e, e.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        let n = this.fetchYAxis();
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineAreaSeries.$t = markType(SplineAreaSeries, 'SplineAreaSeries', SplineSeriesBase.$);
/**
 * @hidden
 */
export class SplineAreaSeriesView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.c7 = null;
        this.df = new Path();
        this.dh = new Path();
        this.dg = new Path();
        this.di = new Path();
        this.db = new Path();
        this.dd = new Path();
        this.dc = new Path();
        this.de = new Path();
        this.c7 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get dj() {
        return this.dh;
    }
    get dk() {
        return this.di;
    }
    get dl() {
        return this.df;
    }
    get dm() {
        return this.dg;
    }
    c8() {
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.di.ak = null;
        this.an();
    }
    c9(a, b, c, d, e, f, g) {
        this.da(a, b, c, d, e, f, g, null);
    }
    da(a, b, c, d, e, f, g, h) {
        this.c7.q4.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c7.q4.j(this.df, this.dh, this.dg, this.di, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.db.ak = this.df.ak;
        this.dd.ak = this.dh.ak;
        this.dc.ak = this.dg.ak;
        this.de.ak = this.di.ak;
        let a = this.bl();
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._fill = a;
        this.dc._opacity = 1;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
        this.de._stroke = a;
        this.de.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
            a.s(this.de);
        }
        else {
            a.s(this.df);
            a.s(this.dg);
            a.s(this.dh);
            a.s(this.di);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dh, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.di, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.df, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 1;
        this.e.ex = -3;
    }
}
SplineAreaSeriesView.$t = markType(SplineAreaSeriesView, 'SplineAreaSeriesView', SplineSeriesBaseView.$);
//# sourceMappingURL=SplineAreaSeries_combined.js.map