/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { StandardDeviationIndicatorStrategy } from "./StandardDeviationIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export class StandardDeviationIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new StandardDeviationIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return StandardDeviationIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(StandardDeviationIndicator.q8));
    }
    set q7(a) {
        this.h(StandardDeviationIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
StandardDeviationIndicator.$t = markType(StandardDeviationIndicator, 'StandardDeviationIndicator', StrategyBasedIndicator.$);
StandardDeviationIndicator.q8 = StrategyBasedIndicator.q4(20, StandardDeviationIndicator.$);
//# sourceMappingURL=StandardDeviationIndicator.js.map