/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { ChaikinVolatilityIndicatorStrategy } from "./ChaikinVolatilityIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var ChaikinVolatilityIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(ChaikinVolatilityIndicator, _super);
    function ChaikinVolatilityIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChaikinVolatilityIndicator.prototype.get_qm = function () {
        return new ChaikinVolatilityIndicatorStrategy();
    };
    Object.defineProperty(ChaikinVolatilityIndicator.prototype, "qm", {
        get: function () {
            return this.get_qm();
        },
        enumerable: true,
        configurable: true
    });
    ChaikinVolatilityIndicator.prototype.get_qz = function () {
        return ChaikinVolatilityIndicator.$;
    };
    Object.defineProperty(ChaikinVolatilityIndicator.prototype, "qz", {
        get: function () {
            return this.get_qz();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ChaikinVolatilityIndicator.prototype, "q7", {
        get: function () {
            return typeGetValue(this.c(ChaikinVolatilityIndicator.q8));
        },
        set: function (a) {
            this.h(ChaikinVolatilityIndicator.q8, a);
        },
        enumerable: true,
        configurable: true
    });
    ChaikinVolatilityIndicator.prototype.qs = function () {
        return this.q7;
    };
    ChaikinVolatilityIndicator.prototype.q1 = function (a) {
        this.q7 = a;
    };
    ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
    ChaikinVolatilityIndicator.q8 = StrategyBasedIndicator.q4(10, ChaikinVolatilityIndicator.$);
    return ChaikinVolatilityIndicator;
}(StrategyBasedIndicator));
export { ChaikinVolatilityIndicator };
//# sourceMappingURL=ChaikinVolatilityIndicator.js.map