/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-angular-core";
import { Visibility_$type } from "igniteui-angular-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-angular-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { PathFigure } from "igniteui-angular-core";
import { LineSegment } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { TranslateTransform } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
/**
 * @hidden
 */
var CrosshairLayer = /** @class */ (function (_super) {
    tslib_1.__extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.xAxisAnnotationFormatLabel = null;
        _this.yAxisAnnotationFormatLabel = null;
        _this.no = null;
        _this.nn = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.fi / 1000;
        _this.mc = a;
        _this.mb = b;
        _this.md = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.bf = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.i2 = function (a) {
        _super.prototype.i2.call(this, a);
        this.ng = a;
    };
    CrosshairLayer.prototype.ni = function () {
        return this.xAxisAnnotationFormatLabel != null;
    };
    CrosshairLayer.prototype.nj = function () {
        return this.yAxisAnnotationFormatLabel != null;
    };
    Object.defineProperty(CrosshairLayer.prototype, "ps", {
        get: function () {
            return new Thickness(1, this.nq, this.ns, this.nr, this.np);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(CrosshairLayer.prototype, "pt", {
        get: function () {
            return new Thickness(1, this.nv, this.nx, this.nw, this.nu);
        },
        enumerable: true,
        configurable: true
    });
    CrosshairLayer.prototype.mv = function (a, b) {
        if (this.nh == null || this.nh == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    };
    CrosshairLayer.prototype.mx = function (a, b) {
        var e_1, _a;
        _super.prototype.mx.call(this, a, b);
        var c = a;
        var d = this.nm;
        var e = this.nl;
        c.ad.clear();
        c.ae.clear();
        c.ac.clear();
        c.af.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.mi(this.nh)) {
            this.os(this.nh, c, d, e);
        }
        else {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.bs.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (this.mi(f)) {
                        this.os(f, c, d, e);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    CrosshairLayer.prototype.mi = function (a) {
        if (!_super.prototype.mi.call(this, a)) {
            return false;
        }
        var b = this.mq(a);
        if (!b.c) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.iw = function () {
        _super.prototype.iw.call(this);
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.ot(this.md, false);
        }
        else {
            this.ot(this.mb, false);
        }
    };
    CrosshairLayer.prototype.os = function (a, b, c, d) {
        var e = this.mq(a);
        if (!e.c) {
            return;
        }
        var f = e.d;
        f = a.lv(f, c, d);
        var g = this.lb;
        if (g == null) {
            g = this.ld;
        }
        if (g == null) {
            g = a.lb;
            if (g != null) {
                g = this.ng.b8(g);
            }
        }
        var h = g;
        var i = g;
        if (this.pk != null) {
            h = this.pk;
        }
        if (this.pl != null) {
            i = this.pl;
        }
        b.ac.add(h);
        b.af.add(i);
        b.ad.add(f.y);
        b.ae.add(f.x);
        if (this.nk) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.pm, this.po, this.pn, this.ps, this.nt, this.pp, this.pr, this.pq, this.pt, this.ny, this.pv == 0, this.pu == 0);
        }
    };
    CrosshairLayer.prototype.ot = function (a, b) {
        var c = false;
        if (this.nn == null) {
            c = true;
            this.no = new List$1(Axis.$, 0);
            this.nn = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.nn, this.no, b, this.nz, this.n0, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    };
    CrosshairLayer.prototype.or = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.af._inner[c];
            f._fill = d.af._inner[c];
        }
        else {
            f._stroke = d.ac._inner[c];
            f._fill = d.ac._inner[c];
        }
        f.ac = this.ey;
        f.ai = this.ll;
        f.ad = this.lm;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.m0 = function (a, b) {
        _super.prototype.m0.call(this, a, b);
        var c = this.ng.b2;
        var d = a;
        var e = d.ad.count;
        var f = 0;
        var g = b.br.left;
        var h = b.br.right;
        var i = b.br.top;
        var j = b.br.bottom;
        var k = this.pv == 0;
        var l = this.pu == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.ad._inner[m]);
            var o = Math.floor(d.ae._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.or(c, f, m, d, true);
                p = q.c;
                f = q.d;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.ak = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.or(c, f, m, d, false);
                p = u.c;
                f = u.d;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.ak = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.ot(this.md, true);
        }
        else {
            this.ot(this.mb, false);
        }
    };
    CrosshairLayer.prototype.c8 = function () {
        return true;
    };
    CrosshairLayer.prototype.i7 = function (a, b, c, d) {
        _super.prototype.i7.call(this, a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.jl(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.jl(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.jl(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[21]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.jl(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:pk:ou', [Brush.$, null], 'HorizontalLineVisibility:pu:ov', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:nk:ow', [0, false], 'SkipUnknownValues:nl:ox', [0, true], 'TargetSeries:nh:oy', [Series.$, null], 'UseInterpolation:nm:oz', [0, true], 'VerticalLineStroke:pl:o0', [Brush.$, null], 'VerticalLineVisibility:pv:o1', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:pm:o2', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:nz:o3', [1, -1], 'XAxisAnnotationOutline:pn:o4', [Brush.$, null], 'XAxisAnnotationPaddingBottom:np:o5', [1, NaN], 'XAxisAnnotationPaddingLeft:nq:o6', [1, NaN], 'XAxisAnnotationPaddingRight:nr:o7', [1, NaN], 'XAxisAnnotationPaddingTop:ns:o8', [1, NaN], 'XAxisAnnotationStrokeThickness:nt:o9', [1, NaN], 'XAxisAnnotationTextColor:po:pa', [Brush.$, null], 'YAxisAnnotationBackground:pp:pb', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:n0:pc', [1, -1], 'YAxisAnnotationOutline:pq:pd', [Brush.$, null], 'YAxisAnnotationPaddingBottom:nu:pe', [1, NaN], 'YAxisAnnotationPaddingLeft:nv:pf', [1, NaN], 'YAxisAnnotationPaddingRight:nw:pg', [1, NaN], 'YAxisAnnotationPaddingTop:nx:ph', [1, NaN], 'YAxisAnnotationStrokeThickness:ny:pi', [1, NaN], 'YAxisAnnotationTextColor:pr:pj', [Brush.$, null]]);
    return CrosshairLayer;
}(AnnotationLayer));
export { CrosshairLayer };
/**
 * @hidden
 */
var CrosshairLayerView = /** @class */ (function (_super) {
    tslib_1.__extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b1 = null;
        _this.b2 = null;
        _this.b3 = null;
        _this.b1 = a;
        _this.b3 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.ap = function () {
        var _this = this;
        _super.prototype.ap.call(this);
        this.b2 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.b9);
            $ret.activate = runOn(_this, _this.b4);
            $ret.disactivate = runOn(_this, _this.b6);
            $ret.destroy = runOn(_this, _this.b5);
            return $ret;
        })());
    };
    CrosshairLayerView.prototype.b9 = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b3.add(a);
        return a;
    };
    CrosshairLayerView.prototype.b4 = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.b6 = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.b5 = function (a) {
        this.b3.remove(a);
    };
    CrosshairLayerView.prototype.b7 = function (a, b, c, d) {
        if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.ak = e;
        }
    };
    CrosshairLayerView.prototype.b8 = function (a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    };
    CrosshairLayerView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b3.count; c++) {
                var d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        for (var b = 0; b < this.b3.count; b++) {
            this.e.a2.exportPathData(a, this.b3._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));
export { CrosshairLayerView };
//# sourceMappingURL=CrosshairLayer_combined.js.map