/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { DetrendedPriceOscillatorIndicatorStrategy } from "./DetrendedPriceOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var DetrendedPriceOscillatorIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(DetrendedPriceOscillatorIndicator, _super);
    function DetrendedPriceOscillatorIndicator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DetrendedPriceOscillatorIndicator.prototype.get_qm = function () {
        return new DetrendedPriceOscillatorIndicatorStrategy();
    };
    Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "qm", {
        get: function () {
            return this.get_qm();
        },
        enumerable: true,
        configurable: true
    });
    DetrendedPriceOscillatorIndicator.prototype.get_qz = function () {
        return DetrendedPriceOscillatorIndicator.$;
    };
    Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "qz", {
        get: function () {
            return this.get_qz();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DetrendedPriceOscillatorIndicator.prototype, "q7", {
        get: function () {
            return typeGetValue(this.c(DetrendedPriceOscillatorIndicator.q8));
        },
        set: function (a) {
            this.h(DetrendedPriceOscillatorIndicator.q8, a);
        },
        enumerable: true,
        configurable: true
    });
    DetrendedPriceOscillatorIndicator.prototype.qs = function () {
        return this.q7;
    };
    DetrendedPriceOscillatorIndicator.prototype.q1 = function (a) {
        this.q7 = a;
    };
    DetrendedPriceOscillatorIndicator.$t = markType(DetrendedPriceOscillatorIndicator, 'DetrendedPriceOscillatorIndicator', StrategyBasedIndicator.$);
    DetrendedPriceOscillatorIndicator.q8 = StrategyBasedIndicator.q4(20, DetrendedPriceOscillatorIndicator.$);
    return DetrendedPriceOscillatorIndicator;
}(StrategyBasedIndicator));
export { DetrendedPriceOscillatorIndicator };
//# sourceMappingURL=DetrendedPriceOscillatorIndicator.js.map