/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { MarkerSeries } from "./MarkerSeries";
import { Base, runOn, Number_$type, enumGetBox, typeCast, Point_$type, fromEnum, markType, markDep } from "igniteui-angular-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { SeriesRenderingArguments } from "./SeriesRenderingArguments";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { Dictionary$2 } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { GeometryGroup } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var PolarBase = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBase, _super);
    function PolarBase() {
        var _this = _super.call(this) || this;
        _this.nl = null;
        _this.ne = null;
        _this.nj = null;
        _this.pb = null;
        _this.pa = null;
        _this.nr = null;
        _this.nt = null;
        _this.nu = null;
        _this.no = new PolarFrame();
        _this.nq = new PolarFrame();
        _this.nn = new PolarFrame();
        _this.ni = null;
        _this.np = null;
        _this.nm = null;
        _this.np = new PolarFrame();
        _this.nq.x = runOn(_this, _this.o9);
        _this.no.x = runOn(_this, _this.o9);
        _this.nn.x = runOn(_this, _this.o9);
        _this.nr = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(_this, _this.om), runOn(_this, _this.oo), runOn(_this, _this.ca), runOn(_this, _this.jt), runOn(_this, _this.ok));
        return _this;
    }
    PolarBase.prototype.bf = function () {
        return new PolarBaseView(this);
    };
    PolarBase.prototype.i2 = function (a) {
        _super.prototype.i2.call(this, a);
        this.nk = a;
    };
    PolarBase.prototype.h1 = function () {
        _super.prototype.h1.call(this);
        this.ng = null;
        this.nh = null;
    };
    PolarBase.prototype.get_c0 = function () {
        return true;
    };
    PolarBase.prototype.n0 = function (a) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var b = this.ng;
        var c = new ScalerParams(1, this.bs.n2, this.l8, b.ca);
        c.c = this.getEffectiveViewport1(this.bi);
        var d = this.nh;
        var e = new ScalerParams(1, this.bs.n2, this.l8, d.ca);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.ma.cc(function (f) {
            if (f._visibility == 0) {
                var g = new SeriesPointOfInterest();
                var h = f.n;
                var i = f.o;
                if (h < _this.l8.left || h > _this.l8.right || i < _this.l8.top || i > _this.l8.bottom) {
                    return;
                }
                g.b = b.d1(h, c);
                g.c = d.d1(i, e);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    };
    PolarBase.prototype.ok = function () {
        if (this.bt.g) {
            this.bt.t();
        }
    };
    PolarBase.prototype.ol = function () {
        this.ni.e(this.nl.w, this.nv, this.nw, this.pb, this.pa, function (a, b) { return Math.cos(b); }, function (a, b) { return Math.sin(b); }, true);
    };
    Object.defineProperty(PolarBase.prototype, "nv", {
        get: function () {
            return this.nt;
        },
        set: function (a) {
            if (this.nt != a) {
                var b = this.nv;
                this.nt = a;
                this.raisePropertyChanged("AngleColumn", b, this.nv);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "nw", {
        get: function () {
            return this.nu;
        },
        set: function (a) {
            if (this.nu != a) {
                var b = this.nw;
                this.nu = a;
                this.raisePropertyChanged("RadiusColumn", b, this.nw);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PolarBase.prototype, "o4", {
        get: function () {
            return this.c(PolarBase.op);
        },
        set: function (a) {
            this.h(PolarBase.op, a);
        },
        enumerable: true,
        configurable: true
    });
    PolarBase.prototype.ik = function () {
        _super.prototype.ik.call(this);
        if (this.nh != null) {
            this.nh.hb(false);
        }
        if (this.ng != null) {
            this.ng.hb(false);
        }
    };
    PolarBase.prototype.h6 = function (a, b, c, d) {
        var e = false;
        this.nk.cr.g$e(a, b, c, d);
        if (this.ng != null && !this.ng.cn()) {
            e = true;
        }
        if (this.nh != null && !this.nh.cn()) {
            e = true;
        }
        if (e) {
            this.jl(true);
        }
    };
    PolarBase.prototype.j0 = function (a, b) {
        this.jl(false);
    };
    PolarBase.prototype.j1 = function (a, b) {
        this.jl(false);
    };
    PolarBase.prototype.dw = function (a, b, c) {
        var d = true;
        if (!_super.prototype.dw.call(this, a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.ng == null || this.nh == null || this.nv == null || this.nw == null || this.nv.count == 0 || this.nw.count == 0 || this.bz == null || this.bz.count != this.nv.count || this.bz.count != this.nw.count || this.ni == null || this.ng.bh == null || this.nh.bh == null || this.ng.kc == this.ng.kb || this.nh.kc == this.nh.kb) {
            d = false;
        }
        return d;
    };
    PolarBase.prototype.jm = function (a) {
        var b;
        var c;
        var d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.h3(true, this.bi);
            return;
        }
        this.pb = b;
        this.pa = c;
        this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
        var e = new SeriesRenderingArguments(this, c, b, a, this.de);
        var f = this.nr.g(e, this.no, this.nn, this.nq, this.nk);
        this.no = f.p1;
        this.nn = f.p2;
        this.nq = f.p3;
    };
    PolarBase.prototype.o9 = function (a) {
        var b = this.ni.h(a.x, a.y, this.pb, this.pa, this.nj.e, this.nj.d, this.nj.g, this.nj.f, this.nj.i, this.nj.h);
        return b;
    };
    PolarBase.prototype.an = function (a) {
        if (a != null && a == this.ng && this.nv != null) {
            return new AxisRange(this.nv.minimum, this.nv.maximum);
        }
        if (a != null && a == this.nh && this.nw != null) {
            return new AxisRange(this.nw.minimum, this.nw.maximum);
        }
        return null;
    };
    PolarBase.prototype.c9 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.ng == null || this.nv == null || this.nh == null || this.nw == null) {
            return false;
        }
        if (d < 0 || d > this.nv.count - 1 || d > this.nw.count - 1) {
            return false;
        }
        var e = this.ng.getScaledAngle(this.nv.item(d));
        var f = this.nh.lx(this.nw.item(d));
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    PolarBase.prototype.fp = function (a) {
        return null;
    };
    PolarBase.prototype.e8 = function (a) {
        return -1;
    };
    PolarBase.prototype.ag = function () {
        return [this.ng, this.nh];
    };
    PolarBase.prototype.fs = function (a, b) {
        var c = this.g2(b);
        if (c == PolarBase.$$p[1]) {
            return this.ft(a, b, this.n9);
        }
        if (c == PolarBase.$$p[5]) {
            return this.ft(a, b, this.of);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    PolarBase.prototype.i7 = function (a, b, c, d) {
        _super.prototype.i7.call(this, a, b, c, d);
        if (this.nk.cr.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nv);
                    c.deregisterColumn(this.nw);
                    this.nv = null;
                    this.nw = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nv = this.bw(this.n9);
                    this.nw = this.bw(this.of);
                }
                if ((this.nh != null && !this.nh.cn()) || (this.ng != null && !this.ng.cn())) {
                    this.jl(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.ng != null && this.nh != null) {
                    this.ni = new PolarAxes(this.nh, this.ng);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if (this.ng != null && !this.ng.cn()) {
                    this.jl(false);
                }
                else if (c != null && d == null) {
                    this.h3(true, this.bi);
                }
                break;
            case PolarBase.$$p[4]:
                if (this.ng != null && this.nh != null) {
                    this.ni = new PolarAxes(this.nh, this.ng);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if (this.nh != null && !this.nh.cn()) {
                    this.jl(false);
                }
                else if (c != null && d == null) {
                    this.h3(true, this.bi);
                }
                if (this.ng != null && !this.ng.cn()) {
                    this.ng.g7();
                }
                break;
            case PolarBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nv);
                    this.nv = this.bw(this.n9);
                }
                break;
            case "AngleColumn":
                this.nk.cr.g$i();
                if (this.ng != null && !this.ng.cn()) {
                    this.jl(false);
                }
                break;
            case PolarBase.$$p[5]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nw);
                    this.nw = this.bw(this.of);
                }
                break;
            case "RadiusColumn":
                this.nk.cr.g$i();
                if (this.nh != null && !this.nh.cn()) {
                    this.jl(false);
                }
                break;
            case PolarBase.$$p[6]:
                this.jl(false);
                this.it();
                break;
            case PolarBase.$$p[3]:
                this.jl(false);
                this.it();
                break;
            case "TransitionProgress":
                this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
                this.pb = this.bi.bs;
                this.pa = this.bi.br;
                this.nq.v = this.n1;
                this.nq.c(this.ez, this.no, this.nn);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.oo(this.nn, this.nk);
                }
                else {
                    this.oo(this.nq, this.nk);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case PolarBase.$$p[2]:
                this.jl(false);
                this.it();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    };
    PolarBase.prototype.ny = function (a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.nx = function (a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    PolarBase.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        var c = b;
        if (a) {
            c.cs.clear();
        }
        c.cr.g$d();
    };
    PolarBase.prototype.nf = function (a, b) {
        var c = a.top - 10;
        var d = a.bottom + 10;
        var e = a.left - 10;
        var f = a.right + 10;
        var g = ((function () {
            var $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    };
    PolarBase.prototype.oj = function (a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        var e = this.bz;
        var _loop_1 = function (f) {
            var g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                var h_1 = { $type: Point_$type, x: this_1.nv.item(f), y: this_1.nw.item(f) };
                var i_1 = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((function () {
                    var $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h_1;
                    $ret.c = i_1;
                    return $ret;
                })()));
            }
        };
        var this_1 = this;
        for (var f = 0; f < b; f++) {
            _loop_1(f);
        }
    };
    PolarBase.prototype.om = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        a.j.clear();
        a.n.clear();
        var e = Math.min(this.nv != null ? this.nv.count : 0, this.nw != null ? this.nw.count : 0);
        if (e < 1) {
            return;
        }
        this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
        this.nl = a;
        this.pa = d;
        this.pb = c;
        b.cp.l(a.j, this.n4, c, d, this.eu);
        if (e <= this.n4) {
            this.oj(a, e, c, d);
        }
        var f = this.nf(d, a.n);
        var g = Math.min(this.ng.kc, this.ng.kb);
        var h = Math.max(this.ng.kb, this.ng.kc);
        b.cr.i = this.n1;
        b.cr.h = 0;
        b.cr.k = this.nh.lr;
        b.cr.j = this.nh.lq;
        b.cr.l = function (i, j) { return _this.ni.c(i, j, c, d, Math.cos); };
        b.cr.m = function (i, j) { return _this.ni.d(i, j, c, d, Math.sin); };
        var i = new List$1(Number_$type, 0);
        for (var j = 0; j < this.nv.count; j++) {
            if (this.nv.item(j) >= g && this.nv.item(j) <= h) {
                i.add(this.nv.item(j));
            }
        }
        var k = this.nw;
        if (i.count != this.nv.count) {
            k = new List$1(Number_$type, 0);
            for (var l = 0; l < this.nv.count; l++) {
                if (this.nv.item(l) >= g && this.nv.item(l) <= h) {
                    k.add(this.nw.item(l));
                }
            }
        }
        b.cr.n(a.n, this.ns, i, k, this.n5, runOn(this.ng, this.ng.getScaledAngle), runOn(this.nh, this.nh.lx), ((function () {
            var $ret = new TrendResolutionParams();
            $ret.b = _this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    };
    PolarBase.prototype.oo = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.l0(b);
        this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
        b.cp.j(a.j, this.mf);
        b.cj();
        var g = this.nf(d, b.cr.g$j.ak);
        b.cr.g$h(a.n, g);
        this.oi(d, c, e, f, b);
    };
    PolarBase.prototype.oi = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    PolarBase.prototype.jw = function () {
        _super.prototype.jw.call(this);
        if (this.fh < 0) {
            return;
        }
        this.nk.cw();
    };
    PolarBase.prototype.jn = function (a, b) {
        _super.prototype.jn.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = this.bh;
        if (!this.df) {
            this.np = new PolarFrame();
            this.om(this.np, c);
        }
        this.df = false;
        this.oo(this.np, c);
        this.dl = false;
    };
    PolarBase.prototype.jk = function (a, b, c, d, e) {
        _super.prototype.jk.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.nm == null) {
            this.nm = new PolarFrame();
        }
        this.om(this.nm, g);
        this.oo(this.nm, g);
    };
    PolarBase.prototype.on = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = tslib_1.__values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = tslib_1.__values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.g(e);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
    };
    PolarBase.prototype.nd = function (a, b, c) {
        this.ol();
        return this.nl.w.toArray();
    };
    PolarBase.prototype.n2 = function (a) {
        var e_3, _a;
        var b = new List$1(Number_$type, 0);
        var c = this.bz;
        try {
            for (var _b = tslib_1.__values(fromEnum(this.nk.cs.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                b.add(c.indexOf(d));
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_3) throw e_3.error; }
        }
        return b;
    };
    PolarBase.prototype.o8 = function (a) {
        return { $type: Point_$type, x: this.nv.item(a), y: this.nw.item(a) };
    };
    PolarBase.prototype.ic = function (a) {
        _super.prototype.ic.call(this, a);
        this.a2.exportTrendlineData(this, a, this.nk.cr.g$j);
    };
    PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
    PolarBase.op = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    PolarBase.$$p = markDep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:ng:oq', [NumericAngleAxis.$, null], 'AngleMemberPath:n9:or', [2], 'ClipSeriesToBounds:nz:os', [0, false], 'MaximumMarkers:n4:ot', [1, 400], 'RadiusAxis:nh:ou', [NumericRadiusAxis.$, null], 'RadiusMemberPath:of:ov', [2], 'UseCartesianInterpolation:n1:o3', [0, true], 'TrendLineType:ns:o1', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:n3:o0', [1, 1.5], 'TrendLinePeriod:n5:oz', [1, 7], 'TrendLineZIndex:n6:o2', [1, 1], 'TrendLineBrush:o5:ow', [Brush.$, null], 'TrendLineDashArray:o6:ox', [DoubleCollection.$], 'TrendLineDashCap:o7:oy', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return PolarBase;
}(MarkerSeries));
export { PolarBase };
/**
 * @hidden
 */
var PolarBaseView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarBaseView, _super);
    function PolarBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.cq = null;
        _this.cp = null;
        _this.cr = null;
        _this.cs = null;
        _this.cq = a;
        _this.cs = new HashPool$2(Base.$, Marker.$);
        _this.ce(_this.cs);
        _this.cr = new PolarTrendLineManager();
        return _this;
    }
    PolarBaseView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        this.cp = this.co();
        if (!this.n) {
            this.cq.n4 = 1000;
            this.by.mb = 2;
        }
    };
    PolarBaseView.prototype.co = function () {
        var _this = this;
        var a = new NumericMarkerManager(0, function (b) { return _this.cs.item(b); }, function (b) { return _this.cq.nj.c.item(b); }, runOn(this, this.cv), runOn(this, this.cn), runOn(this, this.ct));
        a.n = true;
        a.p = runOn(this.cq, this.cq.o8);
        return a;
    };
    PolarBaseView.prototype.cv = function (a) {
        this.cq.on(a, this.cs);
    };
    PolarBaseView.prototype.cn = function () {
        return this.cq.nd(this.cs, this.bs, this.br);
    };
    PolarBaseView.prototype.ct = function () {
        return this.cq.n2(this.cs);
    };
    PolarBaseView.prototype.cu = function (a, b, c, d) {
        if (this.cq.nz) {
            var e = new GeometryGroup();
            this.cq.nh.l5(e, a, b, c, d);
        }
        else {
        }
    };
    PolarBaseView.prototype.cw = function () {
        if (this.cq.o5 != null) {
            this.cq.o4 = this.cq.o5;
        }
        else {
            this.cq.o4 = this.cq.lb;
        }
    };
    PolarBaseView.prototype.cc = function (a) {
        this.cs.f(a);
    };
    PolarBaseView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.cq.ns != 0 && !b) {
                var c = this.cr.g$j;
                c.ac = this.cq.n3;
                c._stroke = this.cq.o4;
                c.ad = this.cq.o7;
                c.ai = this.cq.o6;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    PolarBaseView.prototype.cx = function () {
        return Rect.empty;
    };
    PolarBaseView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cq.n9 + "}" + "</span><br/><span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cq.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cq.of + "}</span></div>";
        return a;
    };
    PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);
    return PolarBaseView;
}(MarkerSeriesView));
export { PolarBaseView };
//# sourceMappingURL=PolarBase_combined.js.map