import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries } from "igniteui-angular-core";
import { ISupportsSizeScale } from "./ISupportsSizeScale";
import { ISupportsFillScale } from "./ISupportsFillScale";
import { Rect } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { Type } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { SeriesView } from "./SeriesView";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { BrushSelectionMode } from "./BrushSelectionMode";
import { MarkerManagerBase } from "./MarkerManagerBase";
/**
 * @hidden
 */
export declare class BubbleSeries extends ScatterBase implements IScaleLegendSeries, ISupportsSizeScale, ISupportsFillScale {
    static $t: Type;
    protected bf(): SeriesView;
    i2(a: SeriesView): void;
    pd: BubbleSeriesView;
    constructor();
    private qq;
    private qp;
    isAttachedTo(a: IChartLegend): boolean;
    protected ci(): boolean;
    protected ie(a: (arg1: any) => void): void;
    readonly pj: IFastItemColumn$1<number>;
    pp: List$1<UIElement>;
    private qo;
    readonly legendReady: boolean;
    readonly minScaleText: string;
    readonly maxScaleText: string;
    forScaleColors(a: (arg1: Brush, arg2: number) => void): boolean;
    p6: string;
    fs(a: any, b: string): any;
    pl: IFastItemColumn$1<number>;
    private ph;
    pe: SizeScale;
    p0: string;
    private pg;
    pk: IFastItemColumn$1<any>;
    pv: string;
    pc: BrushScale;
    private pf;
    pi: IFastItemColumn$1<number>;
    pm: boolean;
    pn: boolean;
    pt: number;
    ps: number;
    po: boolean;
    ob(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    of(a: ScatterFrame, b: ScatterBaseView): void;
    private qb;
    static pq(a: number, b: number, c: number, d: number, e: number): number;
    static pr(a: number, b: number, c: number, d: number, logBase_: number, e: number): number;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    protected nv(a: string, b: FastItemsSourceEventAction): boolean;
    private qa;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    im(): void;
    is(): void;
    protected i7(a: any, b: string, c: any, d: any): void;
    updateSizeScaleGlobals(): void;
    updateFillScaleGlobals(): void;
    pb(a: SizeScale): ActualRange;
    pa(): ActualRange;
    qd(a: List$1<Marker>, b: List$1<number>, c: Rect, d: boolean): void;
    qc(a: List$1<Marker>): void;
    protected get_cy(): boolean;
    readonly actualMarkerBrush: Brush;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CustomPaletteBrushScale extends BrushScale {
    static $t: Type;
    constructor();
    brushSelectionMode: BrushSelectionMode;
    getBrush1(a: number, b: number): Brush;
    protected get_isReady(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class BubbleSeriesView extends ScatterBaseView {
    static $t: Type;
    protected da: BubbleSeries;
    constructor(a: BubbleSeries);
    ap(): void;
    protected cq(): MarkerManagerBase;
    dc(): void;
    dd(): void;
    db(): void;
    getDefaultTooltipTemplate(): string;
}
