import { AnnotationLayer } from "./AnnotationLayer";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Base, Type, Point } from "igniteui-angular-core";
import { Series } from "./Series";
import { Brush } from "igniteui-angular-core";
import { Thickness } from "igniteui-angular-core";
import { CalloutCollisionMode } from "./CalloutCollisionMode";
import { FontInfo } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { CalloutLayerFrame } from "./CalloutLayerFrame";
import { CalloutAnnotationWrapper } from "./CalloutAnnotationWrapper";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { CalloutLabelUpdatingEventArgs } from "./CalloutLabelUpdatingEventArgs";
import { CalloutSeriesSelectingEventArgs } from "./CalloutSeriesSelectingEventArgs";
import { CalloutStyleUpdatingEventArgs } from "./CalloutStyleUpdatingEventArgs";
import { SeriesView } from "./SeriesView";
import { Frame } from "./Frame";
import { Size } from "igniteui-angular-core";
import { CalloutContentUpdatingEventArgs } from "./CalloutContentUpdatingEventArgs";
import { DataContext } from "igniteui-angular-core";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { HashPool$2 } from "igniteui-angular-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { RenderingContext } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { IExecutionContext } from "igniteui-angular-core";
import { Visibility } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class CalloutLayer extends AnnotationLayer {
    static $t: Type;
    constructor();
    private pz;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    da(a: boolean): boolean;
    private od;
    private qb;
    private qc;
    calloutStyleUpdating: (sender: any, args: CalloutStyleUpdatingEventArgs) => void;
    pn: string;
    fs(a: any, b: string): any;
    nu: IFastItemColumn$1<any>;
    private np;
    pu: string;
    nv: IFastItemColumn$1<any>;
    private nq;
    px: string;
    nw: IFastItemColumn$1<any>;
    private nr;
    pk: string;
    nt: IFastItemColumn$1<any>;
    private no;
    n9: boolean;
    pe: string;
    ns: IFastItemColumn$1<any>;
    private nn;
    private oe;
    private oh;
    private p1;
    protected bf(): SeriesView;
    i2(a: SeriesView): void;
    protected nh: CalloutLayerView;
    private oi;
    nk: Series;
    pb: string;
    n8: boolean;
    ob: boolean;
    oa: boolean;
    ot: number;
    q5: Brush;
    q2: Brush;
    ou: number;
    q4: Brush;
    q3: Brush;
    readonly q9: Thickness;
    om: number;
    oo: number;
    on: number;
    ol: number;
    ne: CalloutCollisionMode;
    op: number;
    oq: number;
    pq: string;
    private nl;
    readonly nm: FontInfo;
    protected mv(a: Series, b: boolean): void;
    protected mx(a: Frame, b: SeriesView): void;
    private of;
    private oc;
    private nx;
    private q7;
    protected j1(a: Rect, b: Rect): void;
    protected j0(a: Rect, b: Rect): void;
    private n4;
    private os;
    private q6;
    q8: Rect;
    private n2;
    private p7;
    private p3;
    private ny;
    private ov;
    private ow;
    private nz;
    private p0;
    private n0;
    private or;
    private oj;
    private ox;
    protected mi(a: Series): boolean;
    iw(): void;
    private n3;
    p6(): void;
    calloutContentUpdating: (sender: any, args: CalloutContentUpdatingEventArgs) => void;
    calloutLabelUpdating: (sender: any, args: CalloutLabelUpdatingEventArgs) => void;
    calloutSeriesSelecting: (sender: any, args: CalloutSeriesSelectingEventArgs) => void;
    private og;
    private p8;
    private n6;
    private n7;
    private ok;
    private n5;
    protected bd(): SeriesHitTestMode;
    ar(a: Point, b: boolean): DataContext;
    dh(a: Point, b: boolean): boolean;
    protected qa(a: CalloutLayerFrame, b: boolean): void;
    protected m0(a: Frame, b: SeriesView): void;
    protected c8(): boolean;
    protected i7(a: any, b: string, c: any, d: any): void;
    private p9;
    private n1;
    private p4;
    private p2;
    private p5;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CalloutLayerView extends AnnotationLayerView {
    static $t: Type;
    constructor(a: CalloutLayer);
    protected b1: CalloutLayer;
    private b7;
    ap(): void;
    private b3;
    private ca;
    private cc;
    private cb;
    b6: HashPool$2<CalloutAnnotationWrapper, CalloutView>;
    ck(a: Brush): Brush;
    protected a3(a: RenderingContext, b: boolean): void;
    protected b5(): FontInfo;
    ai(a: any): void;
    private b8;
    cm(a: TextBlock): Size;
    private b9;
    private b2;
    cl(a: any, b: Thickness): Size;
    b4(): IExecutionContext;
    ce(a: CalloutView, b: number, c: number): void;
    cf(a: CalloutView, b: CalloutAnnotationWrapper, c: any): void;
    cg(a: Series): Brush;
    cj(): Brush;
    ci(): Brush;
    ch(a: Series): Brush;
    cd(): void;
}
/**
 * @hidden
 */
export declare class CalloutView extends Base {
    static $t: Type;
    constructor(a: CalloutLayerView);
    private a;
    w: Visibility;
    h(a: RenderingContext): void;
    private j;
    private r;
    private o;
    private q;
    p: Point;
    n: Brush;
    m: Brush;
    l: Brush;
    k: Brush;
    c: number;
    private u;
    private t;
    v: Thickness;
    f: any;
    d: number;
    e: number;
    s(): Size;
    private b;
    i(a: Series, b: CalloutAnnotationWrapper, c: any): void;
    g(a: CalloutLayer, b: FontInfo, c: any): void;
}
