import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Rect } from "igniteui-angular-core";
import { Point, IList$1, Type } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { CategoryMode } from "./CategoryMode";
import { SeriesViewer } from "./SeriesViewer";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { CategoryAxisBaseView } from "./CategoryAxisBaseView";
/**
 * @hidden
 */
export declare class CategoryYAxis extends CategoryAxisBase {
    static $t: Type;
    a3(): AxisView;
    gx(a: AxisView): void;
    k5: CategoryYAxisView;
    protected get_ch(): boolean;
    dx(): number;
    k2(a: Point, b: boolean, c: number): Rect;
    protected k4(a: IList$1<number[]>): number[][];
    gr(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    constructor();
    static readonly ln: DependencyProperty;
    lb: number;
    private k6;
    k8: number;
    d9(): number;
    static readonly lo: DependencyProperty;
    lc: number;
    private k7;
    k9: number;
    private le;
    lg: number;
    private ld;
    lf: number;
    dy(a: number, b: ScalerParams): number;
    private la;
    d1(a: number, b: ScalerParams): number;
    d2(a: number, b: ScalerParams, c: CategoryMode): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    lm(a: number, b: number): void;
    au(): AxisLabelPanelBase;
    dl(): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jz(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    ll(a: any): void;
    cp(): boolean;
    jq(a: SeriesViewer): boolean;
    protected hc(a: boolean): void;
    protected get_a1(): AxisOrientation;
    readonly a1: AxisOrientation;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class CategoryYAxisView extends CategoryAxisBaseView {
    static $t: Type;
    protected bg: CategoryYAxis;
    constructor(a: CategoryYAxis);
}
