import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { ConsolidatedItemsPosition } from "./ConsolidatedItemsPosition";
import { SeriesView } from "./SeriesView";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { Type, Point } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Rect } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { Pool$1 } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { CategorySeriesView } from "./CategorySeriesView";
import { List$1 } from "igniteui-angular-core";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class ColumnSeries extends HorizontalAnchoredCategorySeries {
    static $t: Type;
    protected bf(): SeriesView;
    qu: ColumnSeriesView;
    i2(a: SeriesView): void;
    protected nt(): CategoryTransitionInMode;
    constructor();
    qy: number;
    qz: number;
    protected get_n8(): boolean;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private q0;
    l4(a: Point): Rect;
    dh(a: Point, b: boolean): boolean;
    h3(a: boolean, b: SeriesView): void;
    eg(): number;
    o1(a: CategoryFrame, b: CategorySeriesView): void;
    private qv;
    qw: ConsolidatedItemsPosition;
    private qx;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ColumnSeriesView extends AnchoredCategorySeriesView {
    static $t: Type;
    ap(): void;
    protected c6: ColumnSeries;
    constructor(a: ColumnSeries);
    de(): Rectangle;
    protected c8: List$1<Rectangle>;
    c9(a: Rectangle): void;
    db(a: Rectangle): void;
    da(a: Rectangle): void;
    dc(a: Rectangle, b: number, c: number): void;
    protected z(a: number): any;
    private dd;
    protected y(a: number): any;
    protected a3(a: RenderingContext, b: boolean): void;
    c7: Pool$1<Rectangle>;
    ai(a: any): void;
}
