import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { IHorizontalAnchoredCategorySeriesInteractionManager } from "./IHorizontalAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryMode } from "./CategoryMode";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Axis } from "./Axis";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
    static $t: Type;
    private qf;
    readonly qg: IHorizontalAnchoredCategorySeriesInteractionManager;
    h1(): void;
    xAxis: CategoryAxisBase;
    yAxis: NumericYAxis;
    protected bd(): SeriesHitTestMode;
    nj(): CategoryAxisBase;
    n3(): NumericAxisBase;
    l6(a: Point): Rect;
    private qt;
    protected ql(a: Point, b: Point, c: boolean): boolean;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    dh(a: Point, b: boolean): boolean;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    en(a: Point, b: boolean, c: boolean): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    lv(a: Point, b: boolean, c: boolean): Point;
    fetchXAxis(): Axis;
    fetchYAxis(): Axis;
    pt(a: Axis): void;
    pu(a: Axis): void;
    oe(): boolean;
    protected qb: CategoryAxisBase;
    protected qh: NumericAxisBase;
    qp(a: CategoryAxisBase): void;
    qq(a: NumericYAxis): void;
    nd(a: number, b: number): any[];
    protected i7(a: any, b: string, c: any, d: any): void;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    qj(a: any): boolean;
    qk(a: any): boolean;
    private qd;
    qe: CategoryMode;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
