import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IShortPeriodLongPeriod } from "./IShortPeriodLongPeriod";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class MovingAverageConvergenceDivergenceIndicator extends StrategyBasedIndicator implements IShortPeriodLongPeriod {
    static $t: Type;
    constructor();
    protected get_qm(): IndicatorCalculationStrategy;
    protected readonly qm: IndicatorCalculationStrategy;
    protected get_qz(): Type;
    protected readonly qz: Type;
    shortPeriod: number;
    static readonly ra: DependencyProperty;
    protected qu(): number;
    longPeriod: number;
    static readonly q9: DependencyProperty;
    protected qr(): number;
    signalPeriod: number;
    static readonly rb: DependencyProperty;
    protected p2(): number;
}
