import { Series } from "./Series";
import { DependencyObject } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { Point, Type } from "igniteui-angular-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { RenderSurface } from "./RenderSurface";
import { Dictionary$2 } from "igniteui-angular-core";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { FrameworkElement } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-angular-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { Path } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { StyleSelector } from "./StyleSelector";
import { PointCollection } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ShapeSeriesBase extends Series {
    static $t: Type;
    constructor();
    h1(): void;
    ag(): Axis[];
    fs(a: any, b: string): any;
    m4: string;
    private mk;
    ml: IFastItemColumn$1<any>;
    mg: NumericXAxis;
    mi: NumericYAxis;
    private mo;
    private static mq;
    private convertToListList;
    protected by(a: string): IFastItemColumn$1<any>;
    protected i7(a: any, b: string, c: any, d: any): void;
    mn(a: any): boolean;
    mm(a: any): boolean;
    private mf;
    private mh;
    private mx;
    mt: List$1<Rect>;
    private nc;
    private nk;
    private mv;
    private mb;
    private md;
    private mc;
    private ma;
    protected get_mp(): boolean;
    protected readonly mp: boolean;
    protected ms(): boolean;
    jm(a: boolean): void;
    jk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    protected nb(a: SeriesView): void;
    private static na;
    ik(): void;
    protected j1(a: Rect, b: Rect): void;
    protected j0(a: Rect, b: Rect): void;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    protected get_mr(): boolean;
    protected readonly mr: boolean;
    i2(a: SeriesView): void;
    private mj;
    private mw;
    private me;
    private m8;
    nj: Rect;
    private ne;
    h3(a: boolean, b: SeriesView): void;
    private m9;
    private nd;
    ar(a: Point, b: boolean): DataContext;
    m1(a: number): any;
    protected get_dq(): boolean;
    protected set_dq(a: boolean): void;
    my: number;
    mz: number;
    an(a: Axis): AxisRange;
    protected get_c5(): boolean;
    nl(a: any, b: DependencyObject, c: Style): Style;
    styleShape: (sender: any, e: StyleShapeEventArgs) => void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class ShapeSeriesViewBase extends SeriesView {
    static $t: Type;
    constructor(a: ShapeSeriesBase);
    b3: Dictionary$2<number, FlattenedShape>;
    protected b0(): Pool$1<FrameworkElement>;
    b2(a: Rect): boolean;
    static b5(a: List$1<FlattenedShape>): List$1<PointCollection>;
    protected by: ShapeSeriesBase;
    private b4;
    b8(a: number, b: any, c: Rect, d: List$1<FlattenedShape>): void;
    protected ct(a: number, b: any): FrameworkElement;
    protected abstract ca(a: FrameworkElement, b: PathGeometry): void;
    static cb(a: ShapeSeriesViewBase, b: Path, c: any): void;
    protected cc(a: FrameworkElement, b: any): void;
    protected ce(a: FrameworkElement): void;
    private b9;
    private cm;
    protected abstract cu(a: number, b: List$1<PointCollection>): PathGeometry;
    cj(): void;
    ci(): void;
    private b7;
    cl(a: number, b: number): void;
    cd(): void;
    protected b6: List$1<Path>;
    cq(): FrameworkElement;
    cf(a: FrameworkElement): void;
    cg(a: FrameworkElement): void;
    ch(a: FrameworkElement): void;
    protected b1: Pool$1<FrameworkElement>;
    cv(a: number, b: List$1<PointCollection>, c: boolean): PathGeometry;
    protected bb(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    protected a3(a: RenderingContext, b: boolean): void;
    private bz;
    private cw;
    readonly cx: Style;
    co(a: StyleSelector): void;
    cn(a: Style): void;
    cr(a: Point, b: boolean): FrameworkElement;
    cs(a: Point, b: boolean, c: boolean): FrameworkElement;
    private bv;
    private bx;
    private bw;
    private bu;
    ck(a: number[], b: number[], c: number[], d: number[]): void;
    cp(): void;
    ai(a: any): void;
}
