import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { IndicatorCalculationStrategy } from "./IndicatorCalculationStrategy";
import { Type } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class TRIXIndicator extends StrategyBasedIndicator {
    static $t: Type;
    constructor();
    protected get_qm(): IndicatorCalculationStrategy;
    protected readonly qm: IndicatorCalculationStrategy;
    protected get_qz(): Type;
    protected readonly qz: Type;
    q7: number;
    static readonly q8: DependencyProperty;
    protected qs(): number;
    q1(a: number): void;
}
