import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis } from "./ISortingAxis";
import { IDateTimeAxis } from "./IDateTimeAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { IList$1, Type } from "igniteui-angular-core";
import { AxisOrientation } from "./AxisOrientation";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { CategoryMode } from "./CategoryMode";
import { SortedListView$1 } from "./SortedListView$1";
import { Series } from "./Series";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
/**
 * @hidden
 */
export declare abstract class TimeAxisBase extends CategoryAxisBase implements ISortingAxis, IDateTimeAxis {
    static $t: Type;
    constructor();
    dy(a: number, b: ScalerParams): number;
    e6(a: any, b: string): any;
    private ll;
    private lm;
    d1(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    i$h(): void;
    l1(): void;
    protected l6(): void;
    dateTimeMemberPath: string;
    k5: IFastItemColumn$1<Date>;
    private k4;
    private ld;
    protected le: List$1<number>;
    readonly i$b: List$1<number>;
    protected l2(): void;
    i$e(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected lo(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected ln(a: Date): number;
    i$g(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected lr(a: Rect, b: Rect, c: Rect, d: Rect): number;
    protected lq(a: Date): number;
    i$d(a: number): number;
    i$c(a: number): number;
    protected lp(a: Date, b: SortedListView$1<Date>): number;
    i$f(a: number): number;
    i$i(): void;
    la: boolean;
    private k8;
    protected get_k9(): boolean;
    protected set_k9(a: boolean): void;
    k9: boolean;
    g1(a: string): void;
    g4(a: any): void;
    g3(a: any): void;
    cp(): boolean;
    protected lc(): boolean;
    protected lb(): boolean;
    private lg;
    actualMinimumValue: Date;
    private lf;
    fb(): any;
    actualMaximumValue: Date;
    fa(): any;
    minimumValue: Date;
    maximumValue: Date;
    private l3;
    protected gz(a: any, b: string, c: any, d: any): void;
    private l0;
    protected k6(a: string): IFastItemColumn$1<Date>;
    static k7(a: string, b: CategoryAxisBase): IFastItemColumn$1<Date>;
    au(): AxisLabelPanelBase;
    protected get_a1(): AxisOrientation;
    readonly a1: AxisOrientation;
    protected hc(a: boolean): void;
    protected get_b7(): boolean;
    protected startCursor(): void;
    protected resetCursor(): void;
    StartTimeCursor(): void;
    ResetTimeCursor(): void;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    jz(a: Rect, b: Rect, c: Rect): number;
    protected get_cf(): boolean;
    protected lz(a: Date, b: Date): number;
    preferredCategoryMode(a: Series): CategoryMode;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    readonly i$a: boolean;
    static $$p: string[];
}
