/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { RangeCategorySeries } from "./RangeCategorySeries";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { Axis } from "./Axis";
import { Point_$type, runOn, typeCast, markType, markDep } from "igniteui-angular-core";
import { RangeValueList } from "./RangeValueList";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { PropertyMetadata } from "igniteui-angular-core";
/**
 * @hidden
 */
export class HorizontalRangeCategorySeries extends RangeCategorySeries {
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    h1() {
        super.h1();
        this.xAxis = null;
        this.yAxis = null;
    }
    ah(a) {
        let b = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), this.ly(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), this.ly(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    get_c3() {
        return true;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    getOffsetValue() {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    fc(a, b) {
        return this.fd(a, b, this.xAxis, runOn(this, this.oi), new RangeValueList(this.highColumn, this.lowColumn));
    }
    fe(a, b) {
        return this.ff(a, b, this.xAxis, runOn(this, this.oi), new RangeValueList(this.highColumn, this.lowColumn));
    }
    d9(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.xAxis.j7;
        return this.ea(a, b, this.xAxis, d, e, f, runOn(this, this.oi));
    }
    en(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.xAxis.ca, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.n2, this.bi.br, d);
        return this.ep(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.oi), b, c);
    }
    el(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.xAxis.ca, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.n2, this.bi.br, d);
        return this.ep(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.oi), b, c);
    }
    ej(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.xAxis.ca, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.n2, this.bi.br, d);
        return this.ep(this.highColumn, a, this.xAxis, e, f, runOn(this, this.oi), b, c);
    }
    lr(a, b, c) {
        return this.lx(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ej), (d, e) => this.ff(d, e, this.xAxis, runOn(this, this.oi), this.highColumn), (d, e) => this.fd(d, e, this.xAxis, runOn(this, this.oi), this.highColumn));
    }
    lt(a, b, c) {
        return this.lx(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.el), (d, e) => this.ff(d, e, this.xAxis, runOn(this, this.oi), this.lowColumn), (d, e) => this.fd(d, e, this.xAxis, runOn(this, this.oi), this.lowColumn));
    }
    lv(a, b, c) {
        return this.lx(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    }
    oe() {
        return this.yAxis != null && this.yAxis.cn();
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.h7(typeCast(Axis.$, c));
                this.jc(typeCast(Axis.$, d));
                this.ns.cn.g(this.eu);
                this.jl(false);
                this.it();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.h7(typeCast(Axis.$, c));
                this.jc(typeCast(Axis.$, d));
                this.ns.cn.g(this.eu);
                this.oe();
                this.jl(false);
                this.it();
                break;
        }
    }
    pr(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    pq(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b7) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
HorizontalRangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::pu', [CategoryAxisBase.$, null], 'YAxis::pv', [NumericYAxis.$, null]]);
//# sourceMappingURL=HorizontalRangeCategorySeries.js.map