/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { TRIXIndicatorStrategy } from "./TRIXIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export class TRIXIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.pu = 0;
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 9;
        this.trendLinePeriod = 9;
    }
    get_qm() {
        return new TRIXIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return TRIXIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(TRIXIndicator.q8));
    }
    set q7(a) {
        this.h(TRIXIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
TRIXIndicator.$t = markType(TRIXIndicator, 'TRIXIndicator', StrategyBasedIndicator.$);
TRIXIndicator.q8 = StrategyBasedIndicator.q4(15, TRIXIndicator.$);
//# sourceMappingURL=TRIXIndicator.js.map