/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FinancialSeries } from "./FinancialSeries";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IndicatorDisplayType_$type } from "./IndicatorDisplayType";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { CategoryFrame } from "./CategoryFrame";
import { Number_$type, typeCast, enumGetBox, EnumUtil, runOn, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { ISortingAxis_$type } from "./ISortingAxis";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { FinancialSeriesView } from "./FinancialSeriesView";
import { FinancialBucketCalculator } from "./FinancialBucketCalculator";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { CategorySeries } from "./CategorySeries";
import { NotImplementedException } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
import { Pool$1 } from "igniteui-angular-core";
import { LineGeometry } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { GeometryGroup } from "igniteui-angular-core";
import { Extensions } from "igniteui-angular-core";
import { IndicatorRenderer } from "./IndicatorRenderer";
/**
 * @hidden
 */
var FinancialIndicator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialIndicator, _super);
    function FinancialIndicator() {
        var _this = _super.call(this) || this;
        _this._indicatorColumn = null;
        _this.ps = null;
        _this.ml = new CategoryFrame(3);
        _this.mn = new CategoryFrame(3);
        _this.mk = new CategoryFrame(3);
        _this.indicatorColumn = new List$1(Number_$type, 0);
        _this.ps = new AxisRange(-100, 100);
        return _this;
    }
    FinancialIndicator.prototype.bf = function () {
        return new FinancialIndicatorView(this);
    };
    FinancialIndicator.prototype.i2 = function (a) {
        _super.prototype.i2.call(this, a);
        this.pt = a;
    };
    FinancialIndicator.prototype.p5 = function (a) {
        if (this.m3 != null && !this.m3.cn()) {
            this.jl(true);
        }
    };
    FinancialIndicator.prototype.px = function (a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        var d = this.m3;
        var e = 0;
        if (d != null) {
            e = d.ed(d.km);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    FinancialIndicator.prototype.l4 = function (a) {
        if (this.mi == null || this.m3 == null) {
            return Rect.empty;
        }
        var b = this.lq(a);
        var c = this.bi.bs;
        var d = this.bi.br;
        var e = this.getEffectiveViewport1(this.bi);
        var f = new ScalerParams(0, c, d, this.m3.ca, e);
        f.b = this.eh();
        var g = this.aj(this.mi, this.mk.f, this.of(this.bi), this.oh(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        var h = g[0];
        var i = g[1];
        var j = Math.abs(b.x - h[0]);
        var k = Math.abs(b.x - i[0]);
        var l = this.m3.dy(this.m3.km, f);
        var m = 1;
        if (j < k) {
            var n = h[0] - 0.5 * m;
            var o = h[1];
            var p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            var q = i[0] - 0.5 * m;
            var r = i[1];
            var s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    };
    FinancialIndicator.prototype.dh = function (a, b) {
        var c = this.lv(this.ly(a), true, false);
        if (this.pu == 1) {
            if (this.px(a, c, b)) {
                return true;
            }
        }
        if (this.pu == 1 || this.pu == 0) {
            if (this.dg(a, b)) {
                return true;
            }
        }
        if (this.pu == 2) {
            if (this.dk(a, b)) {
                return true;
            }
        }
        return false;
    };
    FinancialIndicator.prototype.h6 = function (a, b, c, d) {
        _super.prototype.h6.call(this, a, b, c, d);
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            this.mi.i$i();
        }
        if (this.pt.b4) {
            this.pt.b2.g$e(a, b, c, d);
        }
        if (d != null && this.nu.containsKey(d)) {
            var e = this.nu.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            a = 4;
            b = 0;
            c = this.bz.count;
        }
        switch (a) {
            case 3:
                if (this.pw(b, c, d)) {
                    this.p7(b, c, d);
                    this.p5(true);
                }
                break;
            case 2:
                if (this.pw(b, this.bz.count - b, d)) {
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
            case 1:
                if (this.pw(b, this.bz.count - b, d)) {
                    var f = new Array(c);
                    for (var g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
            case 0:
                if (this.pw(b, this.bz.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
            case 4:
                if (this.pw(b, this.bz.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    var h = new Array(c);
                    for (var i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
        }
    };
    Object.defineProperty(FinancialIndicator.prototype, "qi", {
        get: function () {
            return this.c(FinancialIndicator.p8);
        },
        set: function (a) {
            this.h(FinancialIndicator.p8, a);
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicator.prototype.p2 = function () {
        return -1;
    };
    Object.defineProperty(FinancialIndicator.prototype, "indicatorColumn", {
        get: function () {
            return this._indicatorColumn;
        },
        set: function (a) {
            this._indicatorColumn = a;
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicator.prototype.i7 = function (a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.pt.ca();
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pt.b2 = CategoryTrendLineManagerFactory.a(this.pt.b2, this.mi, this.j5, this, this.b2);
                }
                break;
        }
        _super.prototype.i7.call(this, a, b, c, d);
        if (this.pt.b4 && this.pt.b2.g$b(a, b, c, d)) {
            this.jl(false);
            var f = typeCast(FinancialIndicatorView.$, this.bh);
            if (f != null && f.b4) {
                f.b2.g$b(a, b, c, d);
            }
            this.it();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.bz != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    var g = new Array(this.bz.count);
                    for (var h = 0; h < this.bz.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.p7(0, this.bz.count, null);
                    if (this.m3 != null && !this.m3.cn()) {
                        this.my.bu.e(this.eu);
                        this.jl(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case FinancialIndicator.$$p[0]:
                this.h3(true, this.bi);
                this.jl(false);
                this.it();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.bz != null) {
                    if (this.indicatorColumn.count != this.bz.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                        var i = new Array(this.bz.count);
                        for (var j = 0; j < this.bz.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.pw(0, this.bz.count - 1, b)) {
                        this.p6();
                    }
                }
                break;
            case "XAxis":
                if (this.mi != null && (typeCast(ISortingAxis_$type, this.mi) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.p6();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.p6();
                this.it();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    };
    FinancialIndicator.prototype.en = function (a, b, c) {
        if (this.indicatorColumn == null) {
            return _super.prototype.en.call(this, a, b, c);
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.n9(this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        f.c = this.bs.oh;
        return this.ep(this.indicatorColumn, a, this.mi, f, e, runOn(this, this.n8), b, c);
    };
    FinancialIndicator.prototype.fe = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.fe.call(this, a, b);
        }
        return this.ff(a, b, this.mi, runOn(this, this.n8), this.indicatorColumn);
    };
    FinancialIndicator.prototype.fc = function (a, b) {
        if (this.indicatorColumn == null) {
            return _super.prototype.fc.call(this, a, b);
        }
        return this.fd(a, b, this.mi, runOn(this, this.n8), this.indicatorColumn);
    };
    FinancialIndicator.prototype.get_dv = function () {
        return true;
    };
    FinancialIndicator.prototype.pw = function (a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.py(a, b).contains(c)) {
            return true;
        }
        return false;
    };
    FinancialIndicator.prototype.p7 = function (a, b, c) {
        this.pv(a, b);
    };
    FinancialIndicator.prototype.an = function (a) {
        if (this.bz == null) {
            return null;
        }
        if (a != null && a == this.m3) {
            return this.ps;
        }
        return null;
    };
    FinancialIndicator.prototype.c9 = function (a) {
        var b = this.bz != null ? this.bz.indexOf(a) : -1;
        var c = this.bi.bs;
        c = c.copy();
        var d = this.bi.br;
        var e = new Rect(0, 0, 0, 1, 1);
        var f = this.l2(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.mi != null) {
                var g = new ScalerParams(0, e, e, this.mi.ca, f);
                var h = this.mi.dy(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.m3 != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                var i = new ScalerParams(0, e, e, this.m3.ca, f);
                i.b = this.eh();
                var j = this.m3.dy(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    };
    FinancialIndicator.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    };
    FinancialIndicator.prototype.o9 = function (a, b) {
        var _this = this;
        _super.prototype.o9.call(this, a, b);
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.mi;
        var g = this.m3;
        var h = new ScalerParams(0, c, d, f.ca, e);
        var i = new ScalerParams(0, c, d, g.ca, e);
        i.b = this.eh();
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = 0;
        var k = typeCast(ISortingAxis_$type, this.mi);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.n9(c, d, e);
        var l = this.p2();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        var m = typeCast(FinancialIndicatorView.$, b);
        if (m.b4) {
            m.b2.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, function (n) { return _this.mi.dy(n, h); }, function (n) { return _this.m3.dy(n, i); }, ((function () {
                var $ret = new TrendResolutionParams();
                $ret.c = b.bu.b;
                $ret.d = b.bu.c;
                $ret.e = b.bu.d;
                $ret.a = j;
                $ret.b = _this.eu;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        var n = this.mi.d1(2, h) - this.mi.d1(1, h);
        for (var o = b.bu.c; o <= b.bu.d; ++o) {
            var p = void 0;
            if (k == null) {
                p = b.bu.getBucket(o);
            }
            else {
                var q = k.i$b._inner[o];
                var r = k.i$d(q);
                var s = this.indicatorColumn._inner[o];
                var t = s;
                var u = r;
                while (o < b.bu.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    var v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                var w = NaN;
                if (!isNaN_(r)) {
                    w = this.mi.dy(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.dy(p[0], h) + j;
                }
                p[1] = g.dy(p[1], i);
                if (b.bu.b > 1 || k != null) {
                    p[2] = g.dy(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    };
    FinancialIndicator.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        var c = b;
        c.b5(a);
        if (c.b4) {
            c.b2.g$d();
        }
    };
    FinancialIndicator.prototype.mr = function () {
        switch (this.pu) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    };
    FinancialIndicator.prototype.pb = function (a, b) {
        _super.prototype.pb.call(this, a, b);
        var c = typeCast(FinancialIndicatorView.$, b);
        var d = function (e) { return a.f._inner[e][0]; };
        var e = function (f) { return a.f._inner[f][1]; };
        if (c.b4) {
            c.b2.g$d();
            c.b2.g$g(a.p);
        }
        var f = b.br;
        var g = this.getEffectiveViewport1(b);
        var h = 0;
        var i = this.lb;
        var j = this.po;
        if (b.bx(a)) {
            c.b5(false);
            if (a.f.count > 0) {
                switch (this.pu) {
                    case 0:
                        var k = CategorySeries.ne(a.f, a.f.count - 1, f, b.bs, false);
                        c.b9(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.m3 != null) {
                            h = this.od(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        var l = CategorySeries.ne(a.f, a.f.count - 1, f, b.bs, false);
                        c.b7(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.od(b);
                        c.b8(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.bz(a);
        }
        var m = a.f;
        var n = this.bz.count;
        this.mq.x(this, this.nq(), this.mi, runOn(this, this.ma), this.of(b), this.oh(b));
        var o = false;
        var p = this.mq.c;
        if (p != null) {
            o = true;
        }
        this.mq.al = i;
        this.mq.ah = i;
        if (o) {
            var q = new ScalerParams(0, b.bs, b.br, this.mi.ca, g);
            this.mq.f = false;
            this.o8(m, -1, n, this.mi, q, b.n);
        }
        this.mq.ae(c.cr, true, false, true, false);
        this.mq.ae(c.ct, true, false, true, false);
        this.mq.ae(c.cs, false, true, false, false);
        c.cs._opacity = 0.8 * this.mq.i * this.d6;
        this.mq.ae(c.cq, true, false, false, false);
        this.mq.al = j;
        this.mq.ah = j;
        if (o) {
            var r = new ScalerParams(0, b.bs, b.br, this.mi.ca, g);
            this.mq.f = true;
            this.o8(m, -1, n, this.mi, r, b.n);
        }
        this.mq.ae(c.cn, true, false, true, false);
        this.mq.ae(c.cp, true, false, true, false);
        this.mq.ae(c.co, false, true, false, false);
        c.co._opacity = 0.8 * this.mq.i * this.d6;
        this.mq.ae(c.cm, true, false, false, false);
        c.cb();
    };
    FinancialIndicator.prototype.jw = function () {
        _super.prototype.jw.call(this);
        if (this.fh < 0) {
            return;
        }
        if (this.pt.b4) {
            this.pt.cc();
        }
    };
    FinancialIndicator.prototype.p6 = function () {
        if (this.pt.b4) {
            this.pt.b2.g$i();
        }
        this.pv(0, this.indicatorColumn.count);
        if (this.m3 != null && !this.m3.cn()) {
            this.jl(false);
        }
    };
    FinancialIndicator.prototype.ic = function (a) {
        _super.prototype.ic.call(this, a);
        this.a2.exportTrendlineData(this, a, this.pt.b2.g$j);
    };
    FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
    FinancialIndicator.p8 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:pu:p9', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:p0:qa', [1, 0], 'TrendLineType::qg', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::qf', [1, 1.5], 'TrendLinePeriod::qe', [1, 7], 'TrendLineBrush::qb', [Brush.$, null], 'TrendLineZIndex:p1:qh', [1, 1001], 'TrendLineDashArray:qj:qc', [DoubleCollection.$], 'TrendLineDashCap:qk:qd', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return FinancialIndicator;
}(FinancialSeries));
export { FinancialIndicator };
/**
 * @hidden
 */
var FinancialIndicatorBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialIndicatorBucketCalculator, _super);
    function FinancialIndicatorBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    FinancialIndicatorBucketCalculator.prototype.getBucket = function (a) {
        var b = a * this.b;
        var c = Math.min(b + this.b - 1, this.f.b0.indicatorColumn.count - 1);
        var d = NaN;
        var e = NaN;
        for (var f = b; f <= c; ++f) {
            var g = this.f.b0.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    };
    FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
    return FinancialIndicatorBucketCalculator;
}(FinancialBucketCalculator));
export { FinancialIndicatorBucketCalculator };
/**
 * @hidden
 */
var FinancialIndicatorView = /** @class */ (function (_super) {
    tslib_1.__extends(FinancialIndicatorView, _super);
    function FinancialIndicatorView(a) {
        var _this = _super.call(this, a) || this;
        _this.b0 = null;
        _this.b3 = null;
        _this.cr = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cn = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cs = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.co = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.ct = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cp = ((function () {
            var $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        _this.cq = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.cm = ((function () {
            var $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        _this.b1 = null;
        _this.cj = new Path();
        _this.cl = new Path();
        _this.ck = new Path();
        _this.ci = new Path();
        _this.cf = new Path();
        _this.ch = new Path();
        _this.cg = new Path();
        _this.ce = new Path();
        _this.b0 = a;
        _this.b3 = ((function () {
            var $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(_this, _this.cd);
            $ret.destroy = runOn(_this, _this.b6);
            return $ret;
        })());
        return _this;
    }
    FinancialIndicatorView.prototype.bv = function () {
        return new FinancialIndicatorBucketCalculator(this);
    };
    FinancialIndicatorView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.bw.po = ((function () {
                var $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.bw.ey = 2;
        }
    };
    FinancialIndicatorView.prototype.cd = function () {
        return new LineGeometry();
    };
    FinancialIndicatorView.prototype.b6 = function (a) {
    };
    Object.defineProperty(FinancialIndicatorView.prototype, "b2", {
        get: function () {
            if (this.b1 == null) {
                this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.j5, this.e, this.e.b2);
            }
            return this.b1;
        },
        set: function (a) {
            this.b1 = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(FinancialIndicatorView.prototype, "b4", {
        get: function () {
            return this.b1 != null;
        },
        enumerable: true,
        configurable: true
    });
    FinancialIndicatorView.prototype.b5 = function (a) {
        Extensions.e(this.cr.ak);
        Extensions.e(this.cs.ak);
        Extensions.e(this.ct.ak);
        Extensions.e(this.cn.ak);
        Extensions.e(this.co.ak);
        Extensions.e(this.cp.ak);
        Extensions.d(this.cq.ak);
        Extensions.d(this.cm.ak);
        if (a) {
            this.b3.count = 0;
        }
        this.an();
    };
    FinancialIndicatorView.prototype.cb = function () {
    };
    FinancialIndicatorView.prototype.b9 = function (a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bs, this.br, this.cr, this.cn, this.bu.b, this.e.eu, e);
        this.an();
    };
    FinancialIndicatorView.prototype.b7 = function (a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bs, this.br, this.cr, this.cs, this.cn, this.co, e, this.bu.b, this.e.eu, f);
        this.an();
    };
    FinancialIndicatorView.prototype.b8 = function (a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.br, e, this.b3, this.cq, this.cm);
        this.an();
    };
    FinancialIndicatorView.prototype.cc = function () {
        this.b0.qi = null;
        if (this.b0.trendLineBrush != null) {
            this.b0.qi = this.b0.trendLineBrush;
        }
        else {
            this.b0.qi = this.b0.lb;
        }
    };
    FinancialIndicatorView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.cj.ak = this.cr.ak;
        this.cl.ak = this.ct.ak;
        this.ck.ak = this.cs.ak;
        this.ci.ak = this.cq.ak;
        this.cf.ak = this.cn.ak;
        this.ch.ak = this.cp.ak;
        this.cg.ak = this.co.ak;
        this.ce.ak = this.cm.ak;
        this.cj._stroke = a;
        this.cl._stroke = a;
        this.cj.ac = this.e.ey + 3;
        this.cl.ac = this.e.ey + 3;
        this.ck._fill = a;
        this.ck._opacity = 1;
        this.ci._stroke = a;
        this.ci.ac = this.e.ey + 3;
        this.cf._stroke = a;
        this.ch._stroke = a;
        this.cf.ac = this.e.ey + 3;
        this.ch.ac = this.e.ey + 3;
        this.cg._fill = a;
        this.cg._opacity = 1;
        this.ce._stroke = a;
        this.ce.ac = this.e.ey + 3;
    };
    FinancialIndicatorView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                if (this.b0.pu == 2) {
                    a.s(this.ci);
                    a.s(this.ce);
                }
                else {
                    a.s(this.ck);
                    a.s(this.cj);
                    a.s(this.cl);
                    a.s(this.cg);
                    a.s(this.cf);
                    a.s(this.ch);
                }
            }
            else {
                if (this.b0.pu == 2) {
                    a.s(this.cq);
                    a.s(this.cm);
                }
                else {
                    a.s(this.cs);
                    a.s(this.cr);
                    a.s(this.ct);
                    a.s(this.co);
                    a.s(this.cn);
                    a.s(this.cp);
                }
            }
        }
    };
    FinancialIndicatorView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (this.b0.trendLineType != 0 && !b) {
                var c = this.b2.g$j;
                c.ac = this.b0.trendLineThickness;
                c._stroke = this.b0.qi;
                c.ad = this.b0.qk;
                c.ai = this.b0.qj;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    FinancialIndicatorView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.cq, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.cm, "negativeColumnsShape", ["Negative"]);
        this.e.a2.exportPathData(a, this.cr, "positive0", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.ct, "positive1", ["Positive"]);
        this.e.a2.exportPathData(a, this.cs, "positive01", ["PositiveFill"]);
        this.e.a2.exportPathData(a, this.cn, "negative0", ["Negative", "Main"]);
        this.e.a2.exportPathData(a, this.cp, "negative1", ["Negative"]);
        this.e.a2.exportPathData(a, this.co, "negative01", ["NegativeFill"]);
    };
    FinancialIndicatorView.prototype.ca = function () {
        if (this.b4) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.j5, this.e, this.e.b2);
        }
    };
    FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);
    return FinancialIndicatorView;
}(FinancialSeriesView));
export { FinancialIndicatorView };
//# sourceMappingURL=FinancialIndicator_combined.js.map