/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { AnchoredCategorySeries } from "./AnchoredCategorySeries";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { CategoryYAxis } from "./CategoryYAxis";
import { IVerticalAnchoredCategorySeriesInteractionManager_$type } from "./IVerticalAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-angular-core";
import { runOn, typeCast, EnumUtil, markType, markDep } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate } from "igniteui-angular-core";
/**
 * @hidden
 */
var VerticalAnchoredCategorySeries = /** @class */ (function (_super) {
    tslib_1.__extends(VerticalAnchoredCategorySeries, _super);
    function VerticalAnchoredCategorySeries() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.qc = null;
        return _this;
    }
    VerticalAnchoredCategorySeries.prototype.h1 = function () {
        _super.prototype.h1.call(this);
        this.xAxis = null;
        this.yAxis = null;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "qd", {
        get: function () {
            var _this = this;
            if (this.qc == null) {
                this.qc = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, function () { return _this.b2.n; });
            }
            return this.qc;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAnchoredCategorySeries.prototype.get_isVertical = function () {
        return true;
    };
    VerticalAnchoredCategorySeries.prototype.nj = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.n3 = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.getOffsetValue = function () {
        return this.no.r(this.nj(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalAnchoredCategorySeries.prototype.getCategoryWidth = function () {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    VerticalAnchoredCategorySeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.nj(), runOn(this, this.oi), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.nj(), runOn(this, this.oi), this.valueColumn);
    };
    VerticalAnchoredCategorySeries.prototype.d9 = function (a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.oi));
    };
    VerticalAnchoredCategorySeries.prototype.bd = function () {
        if (this.be == 0) {
            return 1;
        }
        else {
            return _super.prototype.bd.call(this);
        }
    };
    VerticalAnchoredCategorySeries.prototype.l6 = function (a) {
        if (!this.hasMarkers || !this.md()) {
            return Rect.empty;
        }
        return this.qd.e$b(this, this.nk.m, a, runOn(this, this.ql));
    };
    VerticalAnchoredCategorySeries.prototype.ql = function (a) {
        return this.pb.c5(a);
    };
    VerticalAnchoredCategorySeries.prototype.dh = function (a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.en = function (a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.nj();
        var f = new ScalerParams(0, this.bs.n2, this.bi.br, e.ca, d);
        var g = this.no.r(e, this.bs.n2, this.bi.br, d);
        return this.ep(this.valueColumn, a, e, f, g, runOn(this, this.oi), b, c);
    };
    VerticalAnchoredCategorySeries.prototype.lv = function (a, b, c) {
        var d = this.nj();
        return this.lx(a, b, c, this.no.r(d, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.n3(), d, null, null, null);
    };
    VerticalAnchoredCategorySeries.prototype.fetchXAxis = function () {
        return this.xAxis;
    };
    VerticalAnchoredCategorySeries.prototype.fetchYAxis = function () {
        return this.yAxis;
    };
    VerticalAnchoredCategorySeries.prototype.pt = function (a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.pu = function (a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    };
    VerticalAnchoredCategorySeries.prototype.oe = function () {
        return this.xAxis != null && this.xAxis.cn();
    };
    VerticalAnchoredCategorySeries.prototype.nd = function (a, b) {
        return this.o8(a, b, this.yAxis);
    };
    VerticalAnchoredCategorySeries.prototype.eb = function (a) {
        return this.qd.e$a(this, a);
    };
    VerticalAnchoredCategorySeries.prototype.oi = function (a) {
        return this.ed(a, this.nj());
    };
    VerticalAnchoredCategorySeries.prototype.e8 = function (a) {
        return truncate(Math.round(this.eb(a)));
    };
    VerticalAnchoredCategorySeries.prototype.fp = function (a) {
        var b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    };
    VerticalAnchoredCategorySeries.prototype.i7 = function (a, b, c, d) {
        _super.prototype.i7.call(this, a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                    this.it();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.oe();
                    this.jl(false);
                    this.it();
                }
                break;
            case "TrendLineType":
                var e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pb.cy = CategoryTrendLineManagerFactory.a(this.pb.cy, this.yAxis, this.j5, this, this.b2);
                }
                break;
        }
    };
    VerticalAnchoredCategorySeries.prototype.qg = function (a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    VerticalAnchoredCategorySeries.prototype.qf = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    Object.defineProperty(VerticalAnchoredCategorySeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.of;
        },
        enumerable: true,
        configurable: true
    });
    VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
    VerticalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::qj', [NumericXAxis.$, null], 'YAxis::qk', [CategoryYAxis.$, null]]);
    return VerticalAnchoredCategorySeries;
}(AnchoredCategorySeries));
export { VerticalAnchoredCategorySeries };
//# sourceMappingURL=VerticalAnchoredCategorySeries.js.map