import { StraightNumericAxisBase } from "./StraightNumericAxisBase";
import { IScaler } from "./IScaler";
import { AxisOrientation } from "./AxisOrientation";
import { AxisView } from "./AxisView";
import { Type, IList$1 } from "igniteui-angular-core";
import { AxisLabelPanelBase } from "./AxisLabelPanelBase";
import { NumericAxisRenderer } from "./NumericAxisRenderer";
import { ScalerParams } from "./ScalerParams";
import { NumericScaler } from "./NumericScaler";
import { Rect } from "igniteui-angular-core";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { StraightNumericAxisBaseView } from "./StraightNumericAxisBaseView";
/**
 * @hidden
 */
export declare class NumericXAxis extends StraightNumericAxisBase implements IScaler {
    static $t: Type;
    a3(): AxisView;
    gx(a: AxisView): void;
    l3: NumericXAxisView;
    constructor();
    au(): AxisLabelPanelBase;
    jl(): NumericAxisRenderer;
    dy(a: number, b: ScalerParams): number;
    d1(a: number, b: ScalerParams): number;
    gs(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    gr(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    gt(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    l4(a: number, b: number): void;
    jo(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    protected hc(a: boolean): void;
    protected hn(a: Rect, b: Rect): void;
    protected get_a1(): AxisOrientation;
    readonly a1: AxisOrientation;
    jq(): NumericScaler;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
}
/**
 * @hidden
 */
export declare class NumericXAxisView extends StraightNumericAxisBaseView {
    static $t: Type;
    protected bi: NumericXAxis;
    constructor(a: NumericXAxis);
}
