import { MarkerSeries } from "./MarkerSeries";
import { Point, Type } from "igniteui-angular-core";
import { PolarAxisInfoCache } from "./PolarAxisInfoCache";
import { SeriesRenderer$2 } from "./SeriesRenderer$2";
import { PolarFrame } from "./PolarFrame";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { NumericAngleAxis } from "./NumericAngleAxis";
import { NumericRadiusAxis } from "./NumericRadiusAxis";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Axis } from "./Axis";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { PolarAxes } from "./PolarAxes";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { PolarTrendLineManager } from "./PolarTrendLineManager";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class PolarBase extends MarkerSeries {
    static $t: Type;
    protected bf(): SeriesView;
    i2(a: SeriesView): void;
    nk: PolarBaseView;
    private nl;
    h1(): void;
    protected get_c0(): boolean;
    n0(a: List$1<SeriesPointOfInterest>): boolean;
    constructor();
    private ok;
    private ol;
    private ne;
    nj: PolarAxisInfoCache;
    private pb;
    private pa;
    nr: SeriesRenderer$2<PolarFrame, PolarBaseView>;
    n9: string;
    of: string;
    protected nv: IFastItemColumn$1<number>;
    private nt;
    protected nw: IFastItemColumn$1<number>;
    private nu;
    ng: NumericAngleAxis;
    nh: NumericRadiusAxis;
    n1: boolean;
    n4: number;
    ns: TrendLineType;
    o5: Brush;
    o4: Brush;
    static readonly op: DependencyProperty;
    n3: number;
    o7: PenLineCap;
    o6: DoubleCollection;
    n5: number;
    n6: number;
    nz: boolean;
    no: PolarFrame;
    nq: PolarFrame;
    nn: PolarFrame;
    ni: PolarAxes;
    ik(): void;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected j0(a: Rect, b: Rect): void;
    protected j1(a: Rect, b: Rect): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    jm(a: boolean): void;
    private o9;
    an(a: Axis): AxisRange;
    c9(a: any): boolean;
    fp(a: Point): any;
    e8(a: Point): number;
    ag(): Axis[];
    fs(a: any, b: string): any;
    protected i7(a: any, b: string, c: any, d: any): void;
    ny(a: any): boolean;
    nx(a: any): boolean;
    h3(a: boolean, b: SeriesView): void;
    private nf;
    oj(a: PolarFrame, b: number, c: Rect, d: Rect): void;
    om(a: PolarFrame, b: PolarBaseView): void;
    oo(a: PolarFrame, b: PolarBaseView): void;
    private oi;
    protected jw(): void;
    np: PolarFrame;
    jn(a: Rect, b: RenderSurface): void;
    private nm;
    jk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    on(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    nd(a: HashPool$2<any, Marker>, b: Rect, c: Rect): Point[];
    n2(a: HashPool$2<any, Marker>): List$1<number>;
    o8(a: number): Point;
    protected ic(a: any): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class PolarBaseView extends MarkerSeriesView {
    static $t: Type;
    protected cq: PolarBase;
    cp: MarkerManagerBase;
    constructor(a: PolarBase);
    cr: PolarTrendLineManager;
    ap(): void;
    protected co(): MarkerManagerBase;
    protected cv(a: IDictionary$2<any, OwnedPoint>): void;
    protected cn(): Point[];
    protected ct(): List$1<number>;
    cu(a: Rect, b: Rect, c: Rect, d: Rect): void;
    cw(): void;
    cs: HashPool$2<any, Marker>;
    cc(a: (arg1: Marker) => void): void;
    protected a2(a: RenderingContext, b: boolean): void;
    protected cx(): Rect;
    getDefaultTooltipTemplate(): string;
}
